﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

using Concurrency;

namespace Driver
{
    class Program
    {
        const int SIZE = 100000;

        static void Main(string[] args)
        {
            ConcurrentSkipList<int> sl = new ConcurrentSkipList<int>();
            Random r = new Random();
            List<int> nums = new List<int>(SIZE);

            for (int i = 0; i < SIZE; i++)
            {
                nums.Add(i);
            }

            Action a = () => TestList(sl, nums) ;

            DateTime now = DateTime.Now;

            Parallel.Invoke(a, a, a, a);

            //Thread t1 = new Thread(() => TestList(sl, nums));
            //t1.Name = "Thread 2";
            //Thread.CurrentThread.Name = "Main Thread";
            //t1.Start();
            //a();
            //t1.Join();

            double totalMilli = (DateTime.Now - now).TotalMilliseconds ;

            Console.WriteLine("count: {0}, addRetry: {1}, removeRetry: {2}", sl.count, sl.addRetry, sl.removeRetry);
            Console.WriteLine("Total time: {0}", totalMilli);
            Console.ReadLine();
        }

        static void TestList(ConcurrentSkipList<int> sl, List<int> nums)
        {
            for (int i = 0; i < 5; i++)
            {
                //Console.WriteLine("{1}: Add {0}", i, Thread.CurrentThread.Name);
                foreach (int n in nums) sl.add(n);
                //Console.WriteLine("{1}: Remove {0}", i, Thread.CurrentThread.Name);
                foreach (int n in nums) sl.remove(n);
            }
        }
    }
}
